diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/spectrum/examples/three-gpp-channel-example.cc ns-3.31/src/spectrum/examples/three-gpp-channel-example.cc
--- ns-3.30.1/src/spectrum/examples/three-gpp-channel-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/spectrum/examples/three-gpp-channel-example.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,254 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 SIGNET Lab, Department of Information Engineering,
+ * University of Padova
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+/**
+* This example shows how to configure the 3GPP channel model classes to
+* compute the SNR between two nodes.
+* The simulation involves two static nodes which are placed at a certain
+* distance from each other and communicates through a wireless channel at
+* 2 GHz with a bandwidth of 18 MHz. The default propagation environment is
+* 3D-urban macro (UMa) and it can be configured changing the value of the
+* string "scenario".
+* Each node hosts a SimpleNetDevice and has an antenna array with 4 elements.
+*/
+
+#include "ns3/core-module.h"
+#include "ns3/three-gpp-channel-model.h"
+#include "ns3/three-gpp-antenna-array-model.h"
+#include <fstream>
+#include "ns3/three-gpp-spectrum-propagation-loss-model.h"
+#include "ns3/net-device.h"
+#include "ns3/simple-net-device.h"
+#include "ns3/node.h"
+#include "ns3/node-container.h"
+#include "ns3/mobility-model.h"
+#include "ns3/constant-position-mobility-model.h"
+#include "ns3/lte-spectrum-value-helper.h"
+#include "ns3/channel-condition-model.h"
+#include "ns3/three-gpp-propagation-loss-model.h"
+
+NS_LOG_COMPONENT_DEFINE ("ThreeGppChannelExample");
+
+using namespace ns3;
+
+static Ptr<ThreeGppPropagationLossModel> m_propagationLossModel; //!< the PropagationLossModel object
+static Ptr<ThreeGppSpectrumPropagationLossModel> m_spectrumLossModel; //!< the SpectrumPropagationLossModel object
+
+/**
+ * Perform the beamforming using the DFT beamforming method
+ * \param thisDevice the device performing the beamforming
+ * \param thisAntenna the antenna object associated to thisDevice
+ * \param otherDevice the device towards which point the beam
+ */
+static void
+DoBeamforming (Ptr<NetDevice> thisDevice, Ptr<ThreeGppAntennaArrayModel> thisAntenna, Ptr<NetDevice> otherDevice)
+{
+  ThreeGppAntennaArrayModel::ComplexVector antennaWeights;
+
+  // retrieve the position of the two devices
+  Vector aPos = thisDevice->GetNode ()->GetObject<MobilityModel> ()->GetPosition ();
+  Vector bPos = otherDevice->GetNode ()->GetObject<MobilityModel> ()->GetPosition ();
+
+  // compute the azimuth and the elevation angles
+  Angles completeAngle (bPos,aPos);
+
+  double hAngleRadian = fmod (completeAngle.phi, 2.0 * M_PI); // the azimuth angle
+  if (hAngleRadian < 0)
+  {
+    hAngleRadian += 2.0 * M_PI;     
+  } 
+  double vAngleRadian = completeAngle.theta; // the elevation angle
+
+  // retrieve the number of antenna elements
+  int totNoArrayElements = thisAntenna->GetNumberOfElements ();
+
+  // the total power is divided equally among the antenna elements
+  double power = 1 / sqrt (totNoArrayElements);
+
+  // compute the antenna weights
+  for (int ind = 0; ind < totNoArrayElements; ind++)
+    {
+      Vector loc = thisAntenna->GetElementLocation (ind);
+      double phase = -2 * M_PI * (sin (vAngleRadian) * cos (hAngleRadian) * loc.x
+                                  + sin (vAngleRadian) * sin (hAngleRadian) * loc.y
+                                  + cos (vAngleRadian) * loc.z);
+      antennaWeights.push_back (exp (std::complex<double> (0, phase)) * power);
+    }
+
+  // store the antenna weights
+  thisAntenna->SetBeamformingVector (antennaWeights);
+}
+
+/**
+ * Compute the average SNR
+ * \param txMob the tx mobility model
+ * \param rxMob the rx mobility model
+ * \param txPow the transmitting power in dBm
+ * \param noiseFigure the noise figure in dB
+ */
+static void
+ComputeSnr (Ptr<MobilityModel> txMob, Ptr<MobilityModel> rxMob, double txPow, double noiseFigure)
+{
+  // Create the tx PSD using the LteSpectrumValueHelper
+  // 100 RBs corresponds to 18 MHz (1 RB = 180 kHz)
+  // EARFCN 100 corresponds to 2125.00 MHz
+  std::vector<int> activeRbs0 (100);
+  for (int i = 0; i < 100 ; i++)
+  {
+    activeRbs0[i] = i;
+  }
+  Ptr<SpectrumValue> txPsd = LteSpectrumValueHelper::CreateTxPowerSpectralDensity (2100, 100, txPow, activeRbs0);
+  Ptr<SpectrumValue> rxPsd = txPsd->Copy ();
+  NS_LOG_DEBUG ("Average tx power " << 10*log10(Sum (*txPsd) * 180e3) << " dB");
+
+  // create the noise PSD
+  Ptr<SpectrumValue> noisePsd = LteSpectrumValueHelper::CreateNoisePowerSpectralDensity (2100, 100, noiseFigure);
+  NS_LOG_DEBUG ("Average noise power " << 10*log10 (Sum (*noisePsd) * 180e3) << " dB");
+
+  // apply the pathloss
+  double propagationGainDb = m_propagationLossModel->CalcRxPower (0, txMob, rxMob);
+  NS_LOG_DEBUG ("Pathloss " << -propagationGainDb << " dB");
+  double propagationGainLinear = std::pow (10.0, (propagationGainDb) / 10.0);
+  *(rxPsd) *= propagationGainLinear;
+
+  // apply the fast fading and the beamforming gain
+  rxPsd = m_spectrumLossModel->CalcRxPowerSpectralDensity (rxPsd, txMob, rxMob);
+  NS_LOG_DEBUG ("Average rx power " << 10*log10 (Sum (*rxPsd) * 180e3) << " dB");
+
+  // compute the SNR
+  NS_LOG_DEBUG ("Average SNR " << 10 * log10 (Sum (*rxPsd) / Sum (*noisePsd)) << " dB");
+
+  // print the SNR and pathloss values in the snr-trace.txt file
+  std::ofstream f;
+  f.open ("snr-trace.txt", std::ios::out | std::ios::app);
+  f << Simulator::Now ().GetSeconds () << " " << 10 * log10 (Sum (*rxPsd) / Sum (*noisePsd)) << " " << propagationGainDb << std::endl;
+  f.close ();
+}
+
+int
+main (int argc, char *argv[])
+{
+  double frequency = 2125.0e6; // operating frequency in Hz (corresponds to EARFCN 2100)
+  double txPow = 49.0; // tx power in dBm
+  double noiseFigure = 9.0; // noise figure in dB
+  double distance = 10.0; // distance between tx and rx nodes in meters
+  uint32_t simTime = 10000; // simulation time in milliseconds
+  uint32_t timeRes = 10; // time resolution in milliseconds
+  std::string scenario = "UMa"; // 3GPP propagation scenario
+
+  Config::SetDefault ("ns3::ThreeGppChannelModel::UpdatePeriod", TimeValue(MilliSeconds (1))); // update the channel at each iteration
+  Config::SetDefault ("ns3::ThreeGppChannelConditionModel::UpdatePeriod", TimeValue(MilliSeconds (0.0))); // do not update the channel condition
+
+  RngSeedManager::SetSeed(1);
+  RngSeedManager::SetRun(1);
+
+  // create and configure the factories for the channel condition and propagation loss models
+  ObjectFactory propagationLossModelFactory;
+  ObjectFactory channelConditionModelFactory;
+  if (scenario == "RMa")
+  {
+    propagationLossModelFactory.SetTypeId (ThreeGppRmaPropagationLossModel::GetTypeId ());
+    channelConditionModelFactory.SetTypeId (ThreeGppRmaChannelConditionModel::GetTypeId ());
+  }
+  else if (scenario == "UMa")
+  {
+    propagationLossModelFactory.SetTypeId (ThreeGppUmaPropagationLossModel::GetTypeId ());
+    channelConditionModelFactory.SetTypeId (ThreeGppUmaChannelConditionModel::GetTypeId ());
+  }
+  else if (scenario == "UMi-StreetCanyon")
+  {
+    propagationLossModelFactory.SetTypeId (ThreeGppUmiStreetCanyonPropagationLossModel::GetTypeId ());
+    channelConditionModelFactory.SetTypeId (ThreeGppUmiStreetCanyonChannelConditionModel::GetTypeId ());
+  }
+  else if (scenario == "InH-OfficeOpen")
+  {
+    propagationLossModelFactory.SetTypeId (ThreeGppIndoorOfficePropagationLossModel::GetTypeId ());
+    channelConditionModelFactory.SetTypeId (ThreeGppIndoorOpenOfficeChannelConditionModel::GetTypeId ());
+  }
+  else if (scenario == "InH-OfficeMixed")
+  {
+    propagationLossModelFactory.SetTypeId (ThreeGppIndoorOfficePropagationLossModel::GetTypeId ());
+    channelConditionModelFactory.SetTypeId (ThreeGppIndoorMixedOfficeChannelConditionModel::GetTypeId ());
+  }
+  else
+  {
+    NS_FATAL_ERROR ("Unknown scenario");
+  }
+
+  // create the propagation loss model
+  m_propagationLossModel = propagationLossModelFactory.Create<ThreeGppPropagationLossModel> ();
+  m_propagationLossModel->SetAttribute ("Frequency", DoubleValue (frequency));
+  m_propagationLossModel->SetAttribute ("ShadowingEnabled", BooleanValue (false));
+
+  // create the spectrum propagation loss model
+  m_spectrumLossModel = CreateObject<ThreeGppSpectrumPropagationLossModel> ();
+  m_spectrumLossModel->SetChannelModelAttribute ("Frequency", DoubleValue (frequency));
+  m_spectrumLossModel->SetChannelModelAttribute ("Scenario", StringValue (scenario));
+
+  // create the channel condition model and associate it with the spectrum and
+  // propagation loss model
+  Ptr<ChannelConditionModel> condModel = channelConditionModelFactory.Create<ThreeGppChannelConditionModel> ();
+  m_spectrumLossModel->SetChannelModelAttribute ("ChannelConditionModel", PointerValue (condModel));
+  m_propagationLossModel->SetChannelConditionModel (condModel);
+
+  // create the tx and rx nodes
+  NodeContainer nodes;
+  nodes.Create (2);
+
+  // create the tx and rx devices
+  Ptr<SimpleNetDevice> txDev = CreateObject<SimpleNetDevice> ();
+  Ptr<SimpleNetDevice> rxDev = CreateObject<SimpleNetDevice> ();
+
+  // associate the nodes and the devices
+  nodes.Get (0)->AddDevice (txDev);
+  txDev->SetNode (nodes.Get (0));
+  nodes.Get (1)->AddDevice (rxDev);
+  rxDev->SetNode (nodes.Get (1));
+
+  // create the tx and rx mobility models, set the positions
+  Ptr<MobilityModel> txMob = CreateObject<ConstantPositionMobilityModel> ();
+  txMob->SetPosition (Vector (0.0,0.0,10.0));
+  Ptr<MobilityModel> rxMob = CreateObject<ConstantPositionMobilityModel> ();
+  rxMob->SetPosition (Vector (distance,0.0,1.6));
+
+  // assign the mobility models to the nodes
+  nodes.Get (0)->AggregateObject (txMob);
+  nodes.Get (1)->AggregateObject (rxMob);
+
+  // create the antenna objects and set their dimensions
+  Ptr<ThreeGppAntennaArrayModel> txAntenna = CreateObjectWithAttributes<ThreeGppAntennaArrayModel> ("NumColumns", UintegerValue (2), "NumRows", UintegerValue (2));
+  Ptr<ThreeGppAntennaArrayModel> rxAntenna = CreateObjectWithAttributes<ThreeGppAntennaArrayModel> ("NumColumns", UintegerValue (2), "NumRows", UintegerValue (2));
+
+  // initialize the devices in the ThreeGppSpectrumPropagationLossModel
+  m_spectrumLossModel->AddDevice (txDev, txAntenna);
+  m_spectrumLossModel->AddDevice (rxDev, rxAntenna);
+
+  // set the beamforming vectors
+  DoBeamforming (txDev, txAntenna, rxDev);
+  DoBeamforming (rxDev, rxAntenna, txDev);
+
+  for (int i = 0; i < floor (simTime / timeRes); i++)
+  {
+    Simulator::Schedule (MilliSeconds (timeRes*i), &ComputeSnr, txMob, rxMob, txPow, noiseFigure);
+  }
+
+  Simulator::Run ();
+  Simulator::Destroy ();
+  return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/spectrum/examples/tv-trans-example.cc ns-3.31/src/spectrum/examples/tv-trans-example.cc
--- ns-3.30.1/src/spectrum/examples/tv-trans-example.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/spectrum/examples/tv-trans-example.cc	2020-06-27 17:38:30.000000000 -0700
@@ -41,7 +41,7 @@
  */
 int main (int argc, char** argv)
 {
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
   
   /* nodes and positions */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/spectrum/examples/tv-trans-regional-example.cc ns-3.31/src/spectrum/examples/tv-trans-regional-example.cc
--- ns-3.30.1/src/spectrum/examples/tv-trans-regional-example.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/spectrum/examples/tv-trans-regional-example.cc	2020-06-27 17:38:30.000000000 -0700
@@ -41,7 +41,7 @@
  */
 int main (int argc, char** argv)
 {
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
   
   /* random seed and run number; adjust these to change random draws */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/spectrum/examples/wscript ns-3.31/src/spectrum/examples/wscript
--- ns-3.30.1/src/spectrum/examples/wscript	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/spectrum/examples/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -20,3 +20,7 @@
     obj = bld.create_ns3_program('tv-trans-regional-example',
                                  ['spectrum', 'mobility', 'core'])
     obj.source = 'tv-trans-regional-example.cc'
+
+    obj = bld.create_ns3_program('three-gpp-channel-example',
+                                 ['spectrum', 'mobility', 'core', 'lte'])
+    obj.source = 'three-gpp-channel-example.cc'
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/spectrum/model/matrix-based-channel-model.cc ns-3.31/src/spectrum/model/matrix-based-channel-model.cc
--- ns-3.30.1/src/spectrum/model/matrix-based-channel-model.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/spectrum/model/matrix-based-channel-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,30 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 SIGNET Lab, Department of Information Engineering,
+ * University of Padova
+ * Copyright (c) 2020 Institute for the Wireless Internet of Things,
+ * Northeastern University
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#include "matrix-based-channel-model.h"
+
+namespace ns3 {
+
+MatrixBasedChannelModel::~MatrixBasedChannelModel()
+{
+}
+
+}
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/spectrum/model/matrix-based-channel-model.h ns-3.31/src/spectrum/model/matrix-based-channel-model.h
--- ns-3.30.1/src/spectrum/model/matrix-based-channel-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/spectrum/model/matrix-based-channel-model.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,134 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 SIGNET Lab, Department of Information Engineering,
+ * University of Padova
+ * Copyright (c) 2020 Institute for the Wireless Internet of Things,
+ * Northeastern University
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#ifndef MATRIX_BASED_CHANNEL_H
+#define MATRIX_BASED_CHANNEL_H
+
+#include <complex.h>
+#include <ns3/object.h>
+#include <ns3/nstime.h>
+#include <ns3/vector.h>
+#include <ns3/three-gpp-antenna-array-model.h>
+#include <tuple>
+
+namespace ns3 {
+
+class MobilityModel;
+
+/**
+ * \ingroup spectrum
+ *
+ * This is an interface for a channel model that can be described
+ * by a channel matrix, e.g., the 3GPP Spatial Channel Models,
+ * which is generally used in combination with antenna arrays
+ */
+class MatrixBasedChannelModel : public Object
+{
+public:
+  /**
+   * Destructor for MatrixBasedChannelModel
+   */
+  virtual ~MatrixBasedChannelModel ();
+
+  typedef std::vector<double> DoubleVector; //!< type definition for vectors of doubles
+  typedef std::vector<DoubleVector> Double2DVector; //!< type definition for matrices of doubles
+  typedef std::vector<Double2DVector> Double3DVector; //!< type definition for 3D matrices of doubles
+  typedef std::vector<ThreeGppAntennaArrayModel::ComplexVector> Complex2DVector; //!< type definition for complex matrices
+  typedef std::vector<Complex2DVector> Complex3DVector; //!< type definition for complex 3D matrices
+
+
+  /**
+   * Data structure that stores a channel realization
+   */
+  struct ChannelMatrix : public SimpleRefCount<ChannelMatrix>
+  {
+    Complex3DVector    m_channel; //!< channel matrix H[u][s][n].
+    DoubleVector       m_delay; //!< cluster delay in nanoseconds.
+    Double2DVector     m_angle; //!< cluster angle angle[direction][n], where direction = 0(AOA), 1(ZOA), 2(AOD), 3(ZOD) in degree.
+    Time               m_generatedTime; //!< generation time
+    std::pair<uint32_t, uint32_t> m_nodeIds; //!< the first element is the s-node ID (the transmitter when the channel was generated), the second element is the u-node ID (the receiver when the channel was generated)
+
+    /**
+     * Destructor for ChannelMatrix
+     */
+    virtual ~ChannelMatrix () = default;
+    
+    /**
+     * Returns true if the ChannelMatrix object was generated
+     * considering node b as transmitter and node a as receiver.
+     * \param aId id of the a node
+     * \param bId id of the b node
+     * \return true if b is the rx and a is the tx, false otherwise
+     */
+    bool IsReverse (const uint32_t aId, const uint32_t bId) const
+    {
+      uint32_t sId, uId;
+      std::tie (sId, uId) = m_nodeIds;
+      NS_ASSERT_MSG ((sId == aId && uId == bId) || (sId == bId && uId == aId),
+                      "This matrix represents the channel between " << sId << " and " << uId);
+      return (sId == bId && uId == aId);
+    }
+  };
+
+  /**
+   * Returns a matrix with a realization of the channel between
+   * the nodes with mobility objects passed as input parameters.
+   *
+   * We assume channel reciprocity between each node pair (i.e., H_ab = H_ba^T),
+   * therefore GetChannel (a, b) and GetChannel (b, a) will return the same
+   * ChannelMatrix object.
+   * To understand if the channel matrix corresponds to H_ab or H_ba, we provide
+   * the method ChannelMatrix::IsReverse. For instance, if the channel
+   * matrix corresponds to H_ab, a call to IsReverse (idA, idB) will return
+   * false, conversely, IsReverse (idB, idA) will return true.
+   *
+   * \param aMob mobility model of the a device
+   * \param bMob mobility model of the b device
+   * \param aAntenna antenna of the a device
+   * \param bAntenna antenna of the b device
+   * \return the channel matrix
+   */
+  virtual Ptr<const ChannelMatrix> GetChannel (Ptr<const MobilityModel> aMob,
+                                               Ptr<const MobilityModel> bMob,
+                                               Ptr<const ThreeGppAntennaArrayModel> aAntenna,
+                                               Ptr<const ThreeGppAntennaArrayModel> bAntenna) = 0;
+  
+  /**
+   * Calculate the channel key using the Cantor function
+   * \param x1 first value
+   * \param x2 second value
+   * \return \f$ (((x1 + x2) * (x1 + x2 + 1))/2) + x2; \f$
+   */
+  static constexpr uint32_t GetKey (uint32_t x1, uint32_t x2)
+  {
+   return (((x1 + x2) * (x1 + x2 + 1)) / 2) + x2;
+  }
+
+  static const uint8_t AOA_INDEX = 0; //!< index of the AOA value in the m_angle array
+  static const uint8_t ZOA_INDEX = 1; //!< index of the ZOA value in the m_angle array
+  static const uint8_t AOD_INDEX = 2; //!< index of the AOD value in the m_angle array
+  static const uint8_t ZOD_INDEX = 3; //!< index of the ZOD value in the m_angle array
+
+};
+
+}; // namespace ns3
+
+#endif // MATRIX_BASED_CHANNEL_H
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/spectrum/model/spectrum-channel.cc ns-3.31/src/spectrum/model/spectrum-channel.cc
--- ns-3.30.1/src/spectrum/model/spectrum-channel.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/spectrum/model/spectrum-channel.cc	2020-06-27 17:38:30.000000000 -0700
@@ -149,5 +149,11 @@
   return m_spectrumPropagationLoss;
 }
 
+Ptr<PropagationLossModel>
+SpectrumChannel::GetPropagationLossModel ()
+{
+  return m_propagationLoss;
+}
+
 
 } // namespace
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/spectrum/model/spectrum-channel.h ns-3.31/src/spectrum/model/spectrum-channel.h
--- ns-3.30.1/src/spectrum/model/spectrum-channel.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/spectrum/model/spectrum-channel.h	2020-06-27 17:38:30.000000000 -0700
@@ -95,7 +95,11 @@
    */
   Ptr<SpectrumPropagationLossModel> GetSpectrumPropagationLossModel (void);
 
-
+  /**
+   * Get the propagation loss model.
+   * \returns a pointer to the propagation loss model.
+   */
+  Ptr<PropagationLossModel> GetPropagationLossModel (void);
 
   /**
    * Used by attached PHY instances to transmit signals on the channel
